#include "hg_regexp.h"

void
hg_re_seg_fault (int n)
{
  printf ("\n\n׸Ʈ Ʈ ߻߽ϴ.\n");
  printf ("--------------------------------------------------------------\n");
  printf ("  ǥ  andsoon@hanmail.net   ֽø\n");
  printf (" ϰڽϴ.\n");
  printf ("-----------------------------------------------------------------\n");
  exit (-1);
}

void
hg_re_not_defined (char * re, int H_TOP, int H_L)
{
  printf ("\n\nƷ  ̸ ߶ andsoon@hanmail.net  ֽø\nϰڽϴ.\n");
  printf ("--------------------------------------------------------------\n");
  printf ("  ǥ : %s\n", re);
  show_stack ();
  printf ("ACTION[%d][%d] :  ǥ  ǵǾ ʽϴ.\n", H_TOP, H_L);
  printf ("andsoon@hanmail.net   ֽø մϴ.\n");
  printf ("-----------------------------------------------------------------\n");
  exit (-1);
}

void
ERROR (char * fmt, ...)
{
  va_list ap;
  
  fprintf (stderr, "[%d] ", LINE);
  va_start (ap, fmt);
  vfprintf (stderr, fmt, ap);
  va_end (ap);
  fputc ('\n', stderr);
  if (++ERRORS == MAX_ERRORS)
    {
      fprintf (stderr, "ִ  Ѱ ġ[%d] Ͽϴ.\n", MAX_ERRORS);
      exit (1);
    }
}

/* ⺻  ʱȭ մϴ. */
void
general_init (void)
{
  int i;
  
  /* { ~ } ǥ    ʱȭ */
  for (i=0; i<LOPT_MERGE_MAX; i++)
    {
      lopt_merge_start[i] = -1;
      lopt_merge_end[i] = -1;
    }
}

/* lexical м */
lexical
lex (void)
{
  char * c;

  do
    {
      FETCH(c, re);
    }
  while (isspace(c[0]) && mode & MODE_IGNORE_SPACE);
  
  /* [ ~ ]  Ȱȭ ɼ ִ Ÿ  */
  switch (c[0])
    {
      case '\0' : return end_t;
      case '\\' : return rev_slash_t;
      case '-'  : return bar_t;
      case '^'  :
	if (mode & MODE_IGNORE_SSAC)
	  goto IDENT_TOKEN;
	else
	  return ssac_t;
      case ']'  :
        /* [ ~ ] ǥ  ŸǷ ٽ Ÿ 
         * Ȱȭ ŵϴ. */
        mode &= ~MODE_NOT_META;
        return r_brac_t;
    }

  if (mode & MODE_NOT_META)
    {
      if (!(mode & MODE_IGNORE_SSAC))
        {
	  mode |= MODE_IGNORE_SSAC;
	}
      goto IDENT_TOKEN;
    }

  /* [ ~ ]  ȭ Ǵ Ÿ  */
  switch (c[0])
    {
      case '('  : return l_par_t;
      case ')'  : return r_par_t;
      case '+'  : return plus_t;
      case '*'  : return star_t;
      case '|'  : return or_t;
      case '['  :
        /*  [ ~ ] ǥ ̹Ƿ Ÿڴ ״
         * ϳ ڷ ν ǰ մϴ. */
        mode |= MODE_NOT_META;
        return l_brac_t;
      case '$'  : return money_t;
      case '/'  : return slash_t;
      case '.'  : return dot_t;
      case ','  : return comma_t;
      case '{'  :
	mode |= (MODE_NEED_RAW_NUM|MODE_IGNORE_SPACE);
	return l_lpar_t;
      case '}'  :
        mode &= ~(MODE_NEED_RAW_NUM|MODE_IGNORE_SPACE);
	last_w = chp;
	*chp = ' ';
	chp++;
	*chp = '\0';
	return r_lpar_t;
      case ':'  : return coron_t;
      case '?'  : return ask_t;
    }
  
IDENT_TOKEN:
  /* Reading one character to chp */
  if ( hg_ishangul_fb (c[0]) )
    {  /* Ko - Hangul */
      last_w = chp;
      *chp = *c;
      chp++;
      FETCH(c, re);
      *chp = *c;
      chp++;
      *chp = '\0';
      return iden_t;
    }
  else
    {      /* En - English */
      last_w = chp;
      /* ڸ ϳϳ иϿ  ʰ   ū
       * ν .
       *
       * { , } ǥĿ Ÿϴ. */
      if (mode & MODE_NEED_RAW_NUM)
        {
          if (isdigit(c[0]))
	    {
	      while (isdigit(c[0]))
	       {
	         *chp = c[0];
	         if (isdigit(c[1]))
	           {
	             FETCH(c, re);
	           }
	         else
	           {
		     chp++;
	             break;
	           }
	         chp++;
	       }
	    }
	  *chp = '\0';
	  return iden_t;
	}
      *chp = *c;
      chp++;
      *chp = '\0';
      return iden_t;
    }
}

/* ޸ Ҵ Լ */
void *
allocate (unsigned bytes)
{
  void * x = malloc (bytes);
  if (x == 0)
    {
      printf ("޸𸮰 ڸϴ.\n");
      exit(1);
    }

  return x;
}

void *
reallocate (void * x, unsigned bytes)
{
  x = realloc (x, bytes);
  if (x == 0)
    {
      printf ("޸𸮰 ڸϴ.\n");
      exit(1);
    }

  return x;
}

/* ڿ  */
char *
copy_s(char *s)
{
  char * new_s = (char *) allocate (strlen (s) + 1);

  strcpy(new_s, s);

  return new_s;
}

/* ؽ */
unsigned char
hash(char *s)
{
  int h;
  char * t;

  for (h = 0, t = s; *t != '\0'; t++)
    h = ( h << 1 ) ^ *t;

  return (h & 0xff);
}

/* ɺ ̺  ɺ , ˻.
 * ɺ ̺  ʴ´ٸ ߰ */
struct symbol *
look_up (char * s)
{
  struct symbol * sym;
  unsigned char h;
  
  for (h = hash(s), sym = hashtab[h]; sym != 0; sym = sym->next)
    {
      if ( strcmp(sym->name, s) == 0)
        return sym;
    }

  sym = (struct symbol *)allocate (sizeof (*sym));
  sym->name = copy_s(s);
  sym->hash = h;
  sym->next = hashtab[h];
  hashtab[h] = sym;
  sym->tail = NULL;
  if (first_b == 0)
    first_b = sym;
  else
    last_b->tail = sym;

  return last_b = sym;
}

/* ÿ PUSH */
void
PUSH (stack_tag tag, int q)
{
  if (SP >= stack + STACK_MAX)
    {
      printf ("ǥ  ִ ũ⸦ Ѵ±.");
      exit(1);
    }

  SP->tag = tag;
  SP->q   = q;
  SP++;
}

int
DUP (int a, int b)
{
  long l, s;
  s = a + b;
  if (s < HASH_MAX)
    l = s*(s + 1)/2 + a;
  else
    {
      s = 2*(HASH_MAX - 1) - s;
      a = HASH_MAX - 1 -a;
      l = s*(s + 1)/2 + a;
      l = HASH_MAX*HASH_MAX - 1 - l;
    }

  return (int)(l/HASH_MAX);
}

int
make_exp (int q, exp_tag tag, ...)
{
  va_list ap;
  struct symbol * sym;
  unsigned char args;
  struct exp * hp, * e;
  int h, q0, q1;

  va_start(ap, tag);
  switch (tag)
    {
      case dot_x:
        h = 0x100;
        goto make_nullary;
      case ask_x:
	h = 0xff;
	goto make_nullary;
      case sym_x:
        sym = va_arg (ap, struct symbol *);
        h = 0x100 + sym->hash;
        args = 0;
        for (hp = exp_hash[h]; hp != 0; hp = hp->tail)
	  {
            if ( sym == hp->body.leaf)
	      {
                if ( q != -1 && q != hp->class)
                  equ_tab[q].value = hp;
                return hp->class;
              }
	  }
        break;
      case ssac_x:
        q0 = va_arg (ap, int);
        h = 0x60 + equ_tab[q0].hash*0x0a/0x200;
        goto make_unary;
      case rev_slash_x: break;
      case zero_x:
        /* ؽ  : 0x0 */
        h = 0;
        goto make_nullary;
      case one_x:
        /* ؽ  : 0x1 */
        h = 1;
 make_nullary:
        args = 0;
        hp = exp_hash[h];
        if (hp != 0)
	  {
            if (q != -1 && q != hp->class)
              equ_tab[q].value = hp;
            return hp->class;
          }
        break;
      case and_x:
        q0 = va_arg (ap, int);
        q1 = va_arg (ap, int);
        /* ؽ  : 0x80 + (0x0 ~ 0x40) */
        h = 0x80 + DUP (equ_tab[q0].hash, equ_tab[q1].hash)/4;
 make_binary:
        args = 2;
        for (hp = exp_hash[h]; hp != 0; hp = hp->tail)
	  {
            if (q0 == hp->body.arg[0] && q1 == hp->body.arg[1])
	      {
                if (q != -1 && q != hp->class)
                  equ_tab[q].value = hp;
                return hp->class;
              }
	  }
        break;
      case or_x:
        q0 = va_arg (ap, int);
        q1 = va_arg (ap, int);
        /* ؽ  : 0x40 + (0x0 ~ 0x20) */
        h = 0x40 + DUP (equ_tab[q0].hash, equ_tab[q1].hash)/8;
        goto make_binary;
      case bar_x:
        q0 = va_arg (ap, int);
        q1 = va_arg (ap, int);
        /* ؽ  : 0x70 + (0x0 ~ 0x10) */
        h = 0x6a + DUP (equ_tab[q0].hash, equ_tab[q1].hash)/16;
        goto make_binary;
      case coron_x:
        q0 = va_arg (ap, int);
        q1 = va_arg (ap, int);
        /* ؽ  : 0xf0 + (0x0 ~ 0x10) */
        h = 0xf0 + DUP (equ_tab[q0].hash, equ_tab[q1].hash)/16;
        goto make_binary;
      case money_x:
        q0 = va_arg (ap, int);
        /* ؽ  : 0xe0 + (0x0 ~ 0x10) */
        h = 0xe0 + equ_tab[q0].hash/0x20;
        goto make_unary;
      case star_x:
        q0 = va_arg (ap, int);
        /* ؽ  : 0x0c + (0x0 ~ 0x14 */
        h = 0x0c + equ_tab[q0].hash*0x14/0x200;
 make_unary:
        args = 1;
        for (hp = exp_hash[h]; hp != 0; hp = hp->tail)
	  {
            printf ("\t## q0 = %d h = %x hp->tag = %d\n", q0, h, hp->tag);
            if (q0 == hp->body.arg[0])
	      {
                if (q != -1 && q != hp->class)
                  equ_tab[q].value = hp;
                return hp->class;
              }
          }
        break;
      case plus_x:
        q0 = va_arg (ap, int);
        /* ؽ  : 0x02 + (0x0 ~ 0x0a) */
        h = 0x02 + equ_tab[q0].hash*0x0a/0x200;
        goto make_unary;
      case comma_x:
        q0 = va_arg (ap, int);
        q1 = va_arg (ap, int);
        /* ؽ  : 0xd0 + (0x0 ~ 0x10) */
        h = 0xd0 + DUP (equ_tab[q0].hash, equ_tab[q1].hash)/16;
        goto make_binary;
      case opt_x:
        q0 = va_arg (ap, int);
        /* ؽ  : 0x20 + (0x0 ~ 0x20) */
        h = 0x20 + equ_tab[q0].hash/0x10;
        goto make_unary;
      case lopt_x:
        q0 = va_arg (ap, int);
        /* ؽ  : 0xc0 + (0x0 ~ 0x10) */
        h = 0xc0 + equ_tab[q0].hash/0x20;
        goto make_unary;
    }
  va_end (ap);
  e = (struct exp *)allocate (sizeof (*e));
  e->tag = tag;
  e->args = args;

  if ( tag == sym_x )
    e->body.leaf = sym;
  else
    {
      e->body.arg = (int *)(args > 0 ? allocate (args*sizeof (int)) : 0 );
      if (args > 0) e->body.arg[0] = q0;
      if (args > 1) e->body.arg[1] = q1;
    }

  e->hash = h;
  e->tail = exp_hash[h];
  exp_hash[h] = e;

  if (q == -1)
    {
      if (equs == equ_max)
        {
          equ_max += EQU_EXTEND;
          equ_tab = (struct equation *)reallocate (equ_tab, sizeof (*equ_tab) * equ_max);
        } 
      equ_tab[equs].hash = h, equ_tab[equs].stack = 0;
      q = equs++;
    }

  equ_tab[q].value = e;
  equ_tab[q].index = 100;
  e->class = q;

  return q;
}

/* Ľ ̺
 *
 * A  Ǿ ִ   ó   κԴϴ */
char *action[10] = {
/*   0         1
   012345678901234567890
   .()+*|&a[]^$\/-.{}:,?  */
  ".&A+*|A&&AA$AAA&&AAAA",  /* 0 RULE:          -> ǥ $ */
  "A&)+*|A&AAAAAAAAAAAAA",  /* 1 PAR:   ǥ  -> '(' ǥ $ ')'    */
  "AAAAAAA&AAAAAAAAA}A,A",  /* 2 LPAR:  ǥ  -> '{' ǥ $ '}'    */
  "AAAAAAAIA]AAAA-AAA:AA",  /* 3 OPT:   ǥ  -> '[' ǥ $ ']'    */
  "vAvAA|AvAvAAAA-AAAvAA",  /* 4 OR:    ǥ  -> ǥ '|' ǥ $    */
  "AAAAAAAwAwAAAAAAAAwAA",  /* 5 BAR:   ǥ  -> ǥ '-' ǥ $    */
  "AAAAAAAIAzAAAA-AAAzAA",  /* 6 CORON: ǥ  -> ǥ ':' ǥ $    */
  "AAAAAAAAAAAAAAAAAuAAA",  /* 7 COMMA: ǥ  -> ǥ ',' ǥ $    */
  "x&xA*xA&&vA$AAA&&AxA&",  /* 8 AND:   ǥ  -> ǥ ǥ $        */
  "y&AA*AA&&yA$AA-AAAAAA"   /* 9 SSAC:  ǥ  -> ^ ǥ $  */
};

/* ? Ÿ ڸ {0, 1} ǥ ٲݴϴ.
 * :-(  ־ ڵ尡   ͽϴ. */
int
ugly_proc_ask(void)
{
  int aa, ab, RHS;

  memset(last_w, '\0', 0x10);
  memcpy(last_w, "0", 2);
  aa = make_exp (-1, sym_x, look_up(last_w));
  memset(last_w, '\0', 0x10);
  memcpy(last_w, "1", 2);
  ab = make_exp (-1, sym_x, look_up(last_w));
  aa = make_exp (-1, comma_x, aa, ab);
  RHS = make_exp (-1, lopt_x, aa);

  return RHS;
}

/* ļ */
int
parse (char * re)
{
  lexical L;
  struct symbol * ID;
  int RHS;

  re_t = re;

  SP = stack;
LHS:
  L = lex ();
  if ( L == iden_t )
    {
      ID = look_up (last_w);
      L = lex ();
      PUSH (RULE, -1);
      RHS = make_exp (-1, sym_x, ID);
      goto END;
    }
  else
      PUSH (RULE, -1);

EXP:
  switch (L)
    {
      case l_par_t  : PUSH (PAR, -1); L = lex (); goto EXP;
      case l_brac_t : PUSH (OPT, -1); L = lex (); goto EXP;
      case l_lpar_t : PUSH (LPAR, -1); L = lex (); goto EXP;
      case ssac_t   : PUSH (SSAC, -1); L = lex (); goto EXP;
      case ask_t    :  /* ? Ÿ  == {0, 1} */
        RHS = ugly_proc_ask();
        L = lex (); goto END;
      case dot_t    :
        RHS = make_exp (-1, dot_x);
        L = lex (); goto END;
      case iden_t   :
        RHS = make_exp (-1, sym_x, look_up (last_w));
        L = lex (); goto END;
      /* {NUM,}   ǥ {NUM, }  
       *  ,}   (space) ִ ó νϵ 
       * ̷ Ʈ ϴ  lex Լ case '}'   ٶ */
      case r_lpar_t :
        RHS = make_exp (-1, sym_x, look_up (last_w));
	goto END;
      case r_par_t  :
      case r_brac_t : (void) POP (); L = lex (); goto END;
      default: 
        ERROR ("EXP 󺧿 ߸  ǥԴϴ.\n");
        hg_re_not_defined (re, TOP, L);
        return -1; 
    }

END:
  switch (action[TOP][L])
    {
      case 'A' : 
        hg_re_not_defined (re, TOP, L);
        break;
      case 'B' : ERROR ("'('  ϴ."); (void) POP (); goto END;
      case 'C' : ERROR ("'['  ϴ."); (void) POP (); goto make_opt;
      case 'D' : ERROR ("')'  ϴ."); L = lex (); goto END;
      case 'E' : ERROR ("']'  ϴ."); L = lex (); goto END;
      case '*' :
        RHS = make_exp (-1, star_x, RHS);
        L = lex (); goto END;
      case '$' :
        RHS = make_exp (-1, money_x, RHS);
        L = lex (); goto END;
      case '+' :
        RHS = make_exp (-1, plus_x, RHS);
        L = lex (); goto END;
      case '&' : PUSH (AND, RHS); goto EXP;
      case 'I' : PUSH (OR, RHS); goto EXP;
      case ':' : PUSH (CORON, RHS); L = lex (); goto EXP;
      case 'v' :
        RHS = make_exp (-1, or_x, POP (), RHS); goto END;
      case 'x' :
        RHS = make_exp (-1, and_x, POP (), RHS); goto END;
      case 'w' :
        RHS = make_exp (-1, bar_x, POP (), RHS); goto END;
      case 'z' :
        RHS = make_exp (-1, coron_x, POP (), RHS); goto END;
      case 'u' :
        RHS = make_exp (-1, comma_x, POP (), RHS); goto END;
      case 'y' :
        (void) POP (); RHS = make_exp (-1, ssac_x, RHS); goto END;
      case ')' : (void) POP (); L = lex (); goto END;
      case 'p' : (void) POP (); goto END;
      case '.' : (void) POP (); return RHS;
      case '|' : PUSH (OR, RHS); L = lex (); goto EXP;
      case '-' : PUSH (BAR, RHS); L = lex (); goto EXP;
      case ',' : PUSH (COMMA, RHS); L = lex (); goto EXP;
      case '}' : (void) POP (); L = lex ();
        RHS = make_exp (-1, lopt_x, RHS); goto END;
      case ']' : (void) POP ();
      case '?' : L = lex ();
make_opt:
		 RHS = make_exp (-1, opt_x, RHS); goto END;
      default:
	printf("˼  ȣԴϴ. Ľ ̺ 캸.\n");
        hg_re_not_defined (re, TOP, L);
	break;
    }

    return -1;
}

void
PUSHQ (int q)
{
  if (equ_tab[q].stack)
    return;

  if (x_s == x_max)
    {
      x_max += X_EXTEND;
      x_stack = reallocate (x_stack, sizeof *x_stack * x_max);
    }

  x_stack[x_s++] = q;
  equ_tab[q].stack = 1;
}

void
POPQ (void)
{
  int q = x_stack[--x_s];

  equ_tab[q].stack = 0;
}

/* hg_isexist   d  ѱ (c,c1)  ϴ  ʴ 
 * ˻ϴ ԼԴϴ.
 *
 *  :  Ѵٸ ߰ߵ  ġ ְ ˸, 
 *           ʴ ٸ -1  մϴ.
 *                                      
 *  :    0   ʴ  
 *         ã ڰ ""̰  d  ù ġ "" 
 *         ġ 0  Ǳ ̴. */

int
hg_isexist (unsigned char *d, unsigned char c, unsigned char c1)
{
  int j=0;
  unsigned char tmp_c, tmp_c1;

  while (d[j] != '\0')
    {
      tmp_c  = d[j++];
      tmp_c1 = d[j++];
      if ((c == tmp_c) && (c1 == tmp_c1))
	return (j-2);
    }

  return -1;

}

void
hangul_list_multiinput (char * midbuf, char * cho, char * jung, char * jong)
{
  char * ch;
  int i=0, j=0, k=0, z=0;

  if (strlen (jong))
    {
        /* ʼ o, ߼ x,  o */
	if (strlen(cho) && !strlen(jung) && strlen(jong))
	  {
            memcpy (midbuf, cho, strlen (cho));
            return;
	  }
	else
          /* ʼ ?, ߼ ?,  o */
          memcpy (midbuf, jong, strlen (jong));
    }
  else
    {
      /* ʼ ?, ߼ x,  x */
      if (!strlen (jung))
        {
          memcpy (midbuf, cho, strlen (cho));
          return;
        }
      /* ʼ x, ߼ ?,  x */
      else if (!strlen (cho))
        {
          memcpy (midbuf, jung, strlen (jung));
          return;
        }
    }

  while (cho[i] != '\0')
    {
      while (jung[j] != '\0')
        {
	  if (!(strlen(jong) && strlen(cho) && strlen(jung)))
	    {
              ch = hg_make_ks5601_f(cho[i], cho[i+1], jung[j], jung[j+1], 0xa4, 0xa8);
              if (ch) 
	        {
                  midbuf[z++] = ch[0], midbuf[z++] = ch[1];
                  free (ch);
                  ch = NULL;
                }
	    }
        while (jong[k] != '\0')
	  {
            ch = hg_make_ks5601_f(cho[i], cho[i+1], jung[j], jung[j+1], jong[k], jong[k+1]);
            if (ch)
	      {
#if HG_RE_DEBUG
		printf(" : %c%c%c%c%c%c\n", cho[i], cho[i+1], jung[j], jung[j+1], jong[k], jong[k+1]);
		printf(" : %s\n", ch);
#endif
                midbuf[z++] = ch[0], midbuf[z++] = ch[1];
                free (ch);
                ch = NULL;
              }
            k += 2;
          }
        k = 0, j += 2;
      }
      j = 0, i += 2;
    }
    midbuf[z] = '\0';
}

void
hangul_remove (unsigned char *buf, unsigned char c, unsigned char c1)
{
  int orig_size=strlen (buf);
  int j=0;
  unsigned char tmp_c, tmp_c1;

  while (buf[j] != '\0')
    {
      tmp_c  = buf[j++];
      tmp_c1 = buf[j++];
  
      if ((c == tmp_c) && (c1 == tmp_c1))
        {
          /* ã */
          buf[j-2] = buf[orig_size-2];
          buf[j-1] = buf[orig_size-1];
          buf[orig_size-2] = '\0';
          buf[orig_size-1] = '\0';
        }
    }
    /* ã  */
}

/* Ư ۿ ѱ ʼ, ߼,     ӽ ۿ
 * ϴ  մϴ.
 *
 * - ߺ ˻縦 ǽմϴ. , ߺȴٸ, װ Ե ʽϴ. */
char *
hangul_list_add (char * hg_type, char c, char c1, char c2, char c3)
{
  int p=0;
  int h1=0, h2=0;
  char * buf;

  MALLOC (buf, char, 0x100);

  h1 = hg_isexist (hg_type, c, c1);
  h2 = hg_isexist (hg_type, c2, c3);
  if (h1 > h2)
    {
      fprintf (stderr, "(ʼ|߼|)    ʽϴ.\n");
      exit(-1);
    }
  else if (h1 == -1 && h2 == -1)
    return buf;

  while (h1 < (h2 + 2))
    {
      if (hg_isexist (buf, hg_type[h1], hg_type[h1+1]) == -1)
        {
          if (p < 0)
	    {
	      printf ("can occur mm free fault");
	      exit (-1);
	    }
          buf[p++] = hg_type[h1];
          buf[p++] = hg_type[h1+1];
        }
      h1+=2;
    }

  return buf;
}

#define MID_BUF_SIZE  0x10000

char *
make_mid_char(char * str1, char * str2)
{
  int is_a=0, is_b=0;
  int i, j=0;
  char * midbuf, * hg1, * hg2;
  char * h_cho, * h_jung, * h_jong;
  char * cho=NULL, * jung=NULL, * jong=NULL;

  /*  ѱ ʼ, ߼,     ش. */
  MALLOC (h_cho, char, 0x100);
  MALLOC (h_jung, char, 0x100);
  MALLOC (h_jong, char, 0x100);

  /* ʼ, ߼,   κ [  ] */
  memcpy (h_cho, "", 38);
  memcpy (h_jung, "¤äĤŤƤǤȤɤʤˤ̤ͤΤϤФѤҤ", 42);
  memcpy (h_jong, "",56);

  if (hg_ishangul (str1[0], str1[1])) is_a++;
  if (hg_ishangul (str2[0], str2[1])) is_b++;
  
  midbuf = (char *) allocate (MID_BUF_SIZE);

  if (!is_a && !is_b)
    {
      for (i=((int)str1[0])+1; i < ((int)str2[0]); i++)
        midbuf[j++] = ((char) i) & 0xff;
    }
  else if (is_a && is_b)
    {
      /* 1) ѱ  ڸ ʼ, ߼,  и */
      hg1 = hg_make_ks5601_b (str1[0], str1[1]);
      hg2 = hg_make_ks5601_b (str2[0], str2[1]);

      /* 2)   ʼ, ߼,   Ѵ. */
      cho  = hangul_list_add (h_cho,  hg1[0], hg1[1], hg2[0], hg2[1]);
      jung = hangul_list_add (h_jung, hg1[2], hg1[3], hg2[2], hg2[3]);
      jong = hangul_list_add (h_jong, hg1[4], hg1[5], hg2[4], hg2[5]);
      /* 3)  Ͽ midbuf  ϼѴ. */
      hangul_list_multiinput (midbuf, cho, jung, jong);
#if HG_RE_DEBUG
      printf ("ѱۺи1 : %s\n", hg1);
      printf ("ѱۺи2 : %s\n", hg2);
      printf ("ʼ : %s\n", cho);
      printf ("߼ : %s\n", jung);
      printf (" : %s\n", jong);
      printf ("߰: %s\n", midbuf);
#endif
      /* 4) (Ʈ1  Ʈ2)  ڸ midbuf  Ѵ. */
      hangul_remove (midbuf, str1[0], str1[1]);
      hangul_remove (midbuf, str2[0], str2[1]);
  
      /* free memory not need */
      if (cho) free (cho);
      if (jung) free (jung);
      if (jong) free (jong);
      if (hg1) free (hg1);
      if (hg2) free (hg2);
    }

  /* free memory */
  free (h_cho); free (h_jung); free (h_jong);

  return midbuf;
}

int
add_state(int states, int * s_list)
{
  int d, i;
  struct state * dp;
  for (d = 0; d < s_s; d++)
    {
      dp = &s_tab[d];
      if (states != dp->states)
        continue;
      for (i = 0; i < states; i++)
        {
          if (s_list[i] != dp->s_list[i])
            break;
	}
      if (i >= states)
        {
          free (s_list);
          return d;
        }
    }
  if ((s_s%7) == 0)
    s_tab = reallocate (s_tab, sizeof *s_tab * (s_s + 8));

  s_tab[s_s].class  = s_s;
  s_tab[s_s].states = states;
  s_tab[s_s].s_list = s_list;

  return s_s++;
}

void
add_buf(struct symbol * LHS, int q)
{
  int diff, i=0, j, s, t;
  struct item * ip;
  char * name;

  if (LHS == NULL)
    goto TO_DOT;

  name = LHS->name;
  for (i = 0; i < i_s; i++)
    {
      diff = strcmp(i_buf[i].LHS->name, name);
      if (diff == 0)
        goto FOUND;
      if (diff > 0)
        break;
    }
TO_DOT:
  if (i_s >= i_max)
    {
      i_max += 8;
      i_buf = reallocate (i_buf, sizeof *i_buf * i_max);
    }

  for (j = i_s++; j > i; j--)
    i_buf[j] = i_buf[j - 1];

  i_buf[i].LHS  = LHS;
  i_buf[i].size = 0;
  i_buf[i].RHS  = 0;
  i_buf[i].index = 100;
FOUND:
  ip = &i_buf[i];
  for (s = 0; s < ip->size; s++)
    {
      if (ip->RHS[s] == q)
        return;
      if (ip->RHS[s] > q)
        break;
    }
  if ((ip->size&7) == 0)
    ip->RHS = reallocate (ip->RHS, sizeof *ip->RHS * (ip->size + 8));
  for (t = ip->size++; t > s; t--)
    ip->RHS[t] = ip->RHS[t - 1];
  ip->RHS[s] = q;
#if HG_RE_DEBUG
  prt_i_buf (ip);
#endif
}

void
add_snext(int q)
{
  int i=0, j, s, t;
  struct item * ip;

  if (i_s >= i_max)
    {
      i_max += 8;
      i_buf = reallocate (i_buf, sizeof *i_buf * i_max);
    }
  for (j = i_s++; j > i; j--)
    i_buf[j] = i_buf[j - 1];
  i_buf[i].LHS  = NULL;
  i_buf[i].size = 0;
  i_buf[i].RHS  = 0;
  i_buf[i].index = 100;

  ip = &i_buf[i];
  for (s = 0; s < ip->size; s++)
    {
      if (ip->RHS[s] == q)
        return;
      if (ip->RHS[s] > q)
        break;
    }
  if ((ip->size&7) == 0)
    ip->RHS = reallocate (ip->RHS, sizeof *ip->RHS * (ip->size + 8));
  for (t = ip->size++; t > s; t--)
    ip->RHS[t] = ip->RHS[t - 1];
  ip->RHS[s] = q;
#if HG_RE_DEBUG
  prt_i_buf (ip);
#endif
}

/* ڿ ϳ ڸ ӽ ۿ ´. */
void getTOKEN (char ** s, char ** b)
{
  char * s1=*s;
  char * b1=*b;

  if (hg_ishangul (*s1, *(s1+1)))
    {
      b1[0] = *s1;
      b1[1] = *(s1+1);
      b1[2] = '\0';
    }
  else
    {
      b1[0] = *s1;
      b1[1] = '\0';
    }

  if (hg_ishangul (*s1, *(s1+1)))
    s1+=2;
  else
    s1++;

  *s=s1;
  *b=b1;
}

/* [ ~ ] ǥ  `-'  ǥ óϴ  մϴ */
void
proc_bar_x (int qx, exp_tag opt_mode)
{
  int c, d, RHS;
  char * mb, * bmb, tbuf[3], * tt = tbuf;
  struct exp * e1, * ea1, * ea2;

  e1 = equ_tab[qx].value;
  switch (e1->tag)
    {
      case bar_x:
        c = e1->body.arg[0];
	d = e1->body.arg[1];
        ea1 = equ_tab[c].value;
	ea2 = equ_tab[d].value;

        mb = make_mid_char(ea1->body.leaf->name, ea2->body.leaf->name);
        bmb = mb;
        if (!strlen (mb))
	  {
            if (c == d)
	      make_exp (qx, opt_mode, c, c);
            else
	      make_exp (qx, opt_mode, c, d);
          }
	else
	  {
            getTOKEN (&mb, &tt);
            RHS = make_exp (-1, opt_mode, c, make_exp (-1, sym_x, look_up (tbuf)));
            while (*mb != '\0')
	      {
                getTOKEN (&mb, &tt);
                RHS = make_exp (-1, opt_mode, RHS, make_exp (-1, sym_x, look_up (tbuf)));
              }
            make_exp (qx, opt_mode, RHS, d);
          }
        free (bmb);
        break;
      default:
	printf ("e1:  ó  . %d", e1->tag);
        exit(-1);
        break;    
    }
}

/* ǥĿ   Ȱ ǥ num1  ŭ 
 *  Ȱ մϴ. */
int
add_repeat_andx (int q1, int num)
{
  int i;
  int r1;

  if (num == 1)
	return q1;

  for (i=0; i<(num-1); i++) {
	if (i == 0)
	  {
		r1 = make_exp (-1, and_x, q1, q1);
		continue;
	  }
	r1 = make_exp (-1, and_x, r1, q1);
  }

  return r1;
}

/* lopt_merge_start  lopt_merge_end   { } ǥ 
 *   */
void
lopt_merge_add (int num1, int num2)
{
  int i=0;

  while(lopt_merge_start[i] != -1 && lopt_merge_end[i] != -1)
    {
      i++;
    }

  lopt_merge_start[i] = num1;
  lopt_merge_end[i]   = num2;
}

/* { ~ }  ǥ óϱ  ƾ Դϴ. */
int
proc_lopt_x (struct state * sp, int qx, int q1, int q2)
{
  int a, b, b1, b2, r1, r2;
  int num1, num2;
  struct exp * e1, * e2, * ea1, * eb1, * eb2;

#if HG_RE_DEBUG
  printf("proc_lopt_x : [%d/%d/%d]\n", qx, q1, q2);
#endif
  e1 = equ_tab[q2].value;
  e2 = equ_tab[q1].value;
  switch(e1->tag)
    {
      case lopt_x:
	a = e1->body.arg[0];
	ea1 = equ_tab[a].value;
	switch(ea1->tag)
	  {
	    case sym_x:
	      /* {5}    Ÿϴ */
	      num1 = atoi (ea1->body.leaf->name);
	      r1 = add_repeat_andx (q1, num1-1);
	      (void) make_exp (qx, and_x, q1, r1);
	      return 1;
	    case comma_x:
	      b1 = ea1->body.arg[0];
	      b2 = ea1->body.arg[1];
	      eb1 = equ_tab[b1].value;
	      eb2 = equ_tab[b2].value;
	      if (!strcmp(eb2->body.leaf->name, " "))
	        {
		  if(!strcmp(eb1->body.leaf->name, "0"))
		    {
		      make_exp (qx, star_x, q1); /* ǥ(*) Ÿ */
		      return 1;
		    }
		  else if(!strcmp(eb1->body.leaf->name, "1"))
		    {
		      make_exp (qx, plus_x, q1); /* ϱ(+) Ÿ */
		      return 1;
		    }
		  else
		    {
		      /* 1  ū Ÿϴ. */
		      num1 = atoi (eb1->body.leaf->name);
		      if (num1 < 2)
			ERROR ("{ ~ } ǥ  ڰ ̻մϴ");

		      r1 = add_repeat_andx (q1, num1-1);
		      r2 = make_exp (-1, plus_x, q1);
		      (void) make_exp (qx, and_x, r1, r2);

		      return 1;
		    }
		}
	      else
	        {
		  if(!strcmp (eb1->body.leaf->name, "0")
		     && !strcmp (eb2->body.leaf->name, "1"))
		    {
		      sp->lopt_merge = 1;
		      num1 = atoi (eb1->body.leaf->name);
		      num2 = atoi (eb2->body.leaf->name);
		      lopt_merge_add (num1, num2);
		      (void) make_exp (qx, or_x, q1, make_exp(-1, zero_x));
		      return 1;
		    }
		  else
		    {
		      /* {1, 2} Ȥ {2, 3}    Ÿϴ */
		      sp->lopt_merge = 1;
		      num1 = atoi (eb1->body.leaf->name);
		      num2 = atoi (eb2->body.leaf->name);

		      /*  Merge ۾ write_states Լ
		       * ̷ ϴ. */
		      lopt_merge_add (num1, num2);
		      r1 = add_repeat_andx (q1, num2-1);
		      (void) make_exp (qx, and_x, q1, r1);

		      return 1;
		    }
		}
	      break;
	    default:
	      prt_equtab(0, 500);
	      printf ("ea1:  ó  . %d", ea1->tag);
	      exit(-1);
	      break;
	  }
      case and_x:
	a = e1->body.arg[0];
	b = e1->body.arg[1];
	ea1 = equ_tab[a].value;
        if (ea1->tag == lopt_x)
          {
#if HG_RE_DEBUG
	    printf("[%d/%d/%d/%d/%d]\n", a, b, qx, q2, q1);
#endif
	    (void) make_exp (q2, and_x, q1, a);
	    (void) make_exp (qx, and_x, q2, b);
	    if (proc_lopt_x(sp, q2, q1, a))
	      return 1;
	  }
	break;
      default:
#if HG_RE_DEBUG
	printf(".; ̰ óؾϳ ƾ ϳ?");
#endif
	break;
    }
  
  return 0;
}

void
form_state(int q)
{
  int i, s, s1, x;
  exp_tag opt_mode=and_x;
  struct state * sp;
  
  i_buf = 0; i_max = 0;
  s_tab = 0; s_s = 0;
  add_state(1, &q);
  for (s = 0; s < s_s; s++)
    {
#if HG_RE_DEBUG
      printf ("\ts : %d s_s : %d\n", s, s_s);
#endif
      sp = &s_tab[s];
      for (x_s = 0, s1 = 0; s1 < sp->states; s1++)
        PUSHQ (sp->s_list[s1]);
      for (sp->empty = 0, i_s = 0, x = 0; x < x_s; x++)
        {
          int qx = x_stack[x], q1, q2;
          struct exp * e;
EVALUATE:
#if HG_RE_DEBUG
          printf ("\tx : %d x_s : %d, qx : %d | ", x, x_s, qx);
          prt_x_stack ();
#endif
          e = equ_tab[qx].value;
          switch (e->tag)
	    {
              case sym_x:
                add_buf(e->body.leaf, make_exp (-1, one_x));
                break;
             case dot_x:
                add_snext(make_exp (-1, one_x));
                break;
              case ssac_x:
                if (opt_mode == or_x)
                  sp->reverse = 1;
                else
                  sp->ssac_got = 1;
                q1 = e->body.arg[0];
                PUSHQ (q1);
                break;
              case money_x:
                sp->money = 1;
                q1 = e->body.arg[0];
                PUSHQ (q1);
                break;
              case rev_slash_x: printf ("(*-_-*)"); break;
              case zero_x: break;
              case one_x: 
                sp->empty = 1;
                break;
              case and_x:
                {
                  int a, b;
                  struct exp * e1;
                  q1 = e->body.arg[0];
                  q2 = e->body.arg[1];
                  e1 = equ_tab[q1].value;
                  switch (e1->tag)
		    {
                      case sym_x:
			if (proc_lopt_x (sp, qx, q1, q2))
			  {
			    sp->lopt_merge = 1;
			    goto EVALUATE;
			  }
                        add_buf(e1->body.leaf, q2);
                        break;
                      case dot_x:
                        add_snext(q2);
                        break;
                      case ssac_x:
                        if (opt_mode == or_x)
                          sp->reverse = 1;
                        else
                          sp->ssac_got = 1;
                        a = e1->body.arg[0];
                        make_exp (qx, or_x, make_exp (-1, zero_x), make_exp (-1, and_x, a, q2));
                        goto EVALUATE;
                      case money_x:
		        printf ("(*-_-*) money_x ó"); break;
                      case rev_slash_x:
		        printf ("(*-_-*) rev_slash_x ó"); break;
                      case zero_x:
                        make_exp (qx, zero_x); break;
                      case one_x:
                        equ_tab[qx].value = equ_tab[q2].value; goto EVALUATE;
                      case and_x:
                        a = e1->body.arg[0];
                        b = e1->body.arg[1];
                        make_exp (qx, and_x, a, make_exp (-1, and_x, b, q2));
                        goto EVALUATE;
                      case or_x:
                        a = e1->body.arg[0];
                        b = e1->body.arg[1];
                        make_exp (qx, or_x, make_exp (-1, and_x, a, q2), make_exp (-1, and_x, b, q2));
                        goto EVALUATE;
                      case bar_x:
                        proc_bar_x (q1, opt_mode);
                        goto EVALUATE;
                      case star_x:
                        a = e1->body.arg[0];
                        make_exp (qx, or_x, q2, make_exp (-1, and_x, a, qx));
                        goto EVALUATE;
                      case plus_x:
                        a = e1->body.arg[0];
                        make_exp (qx, and_x, a, make_exp (-1, or_x, q2, qx));
                        goto EVALUATE;
                      case comma_x:
		        printf ("(*-_-*) comma_x ó"); break;
                      case opt_x:
                        opt_mode = or_x;
                        a = e1->body.arg[0];
                        make_exp (qx, or_x, make_exp (-1, zero_x), make_exp (-1, and_x, a, q2));
			  goto EVALUATE;
			case lopt_x:
			printf("proc_lopt_x(lopt_x) : %d\n ̷  óǸ ȵǿ.", proc_lopt_x (sp, qx, q1, q2));
		        printf ("(*-_-*) lopt_x ó"); break;
                      case coron_x:
		        printf ("(*-_-*) coron_x ó"); break;
		      case ask_x:
		        printf ("(*-_-*) ask_x ó"); break;
                    }
                }
                break;
              case or_x:
                q1 = e->body.arg[0];
                q2 = e->body.arg[1];
                PUSHQ (q1);
                PUSHQ (q2);
                break;
              case bar_x:
                proc_bar_x (qx, opt_mode);
                goto EVALUATE;
              case star_x:
                q1 = e->body.arg[0];
                make_exp (qx, or_x, make_exp (-1, one_x), make_exp (-1, plus_x, q1));
                goto EVALUATE;
              case plus_x:
                q1 = e->body.arg[0];
                make_exp (qx, and_x, q1, make_exp (-1, star_x, q1));
                goto EVALUATE;
              case comma_x: printf ("(*-_-*) ! ̷~ comma_x"); break;
              case opt_x:
                opt_mode = or_x;
                q1 = e->body.arg[0];
                PUSHQ (q1);
                break;
              case lopt_x:
		printf ("(*-_-*) lopt_x "); break;
              case coron_x: printf ("(*-_-*)"); break;
	      case ask_x: printf ("(*_*) ask_x"); break;
            }
       }
    while (x_s > 0)
      POPQ ();
    opt_mode = and_x;
    sp->shifts = i_s;
    sp->sh_list = allocate (sizeof *sp->sh_list * i_s);
    for (i = 0; i < i_s; i++)
      {
        sp->sh_list[i].LHS = i_buf[i].LHS;
        sp->sh_list[i].RHS = add_state(i_buf[i].size, i_buf[i].RHS);
      }
#if HG_RE_DEBUG
    prt_s_tab(sp);
#endif
  }

  free (i_buf);
  i_buf = 0;
  i_s = i_max = 0;
}

void add_equiv(int L, int R)
{
  int e;
  struct state * sL, * sR;

  L = s_tab[L].class, R = s_tab[R].class;
  if (L == R)
    return;
  if (L > R)
    L ^= R, R ^= L, L ^= R;
  sL = &s_tab[L], sR = &s_tab[R];
  for (e = 0; e < e_s; e++)
    {
      if (sL == e_tab[e].L && sR == e_tab[e].R)
        return;
    }
  if (e_s >= e_max)
    e_max += 8, e_tab = reallocate (e_tab, sizeof *e_tab * e_max);
  e_tab[e_s].L = sL, e_tab[e_s].R = sR, e_s++;
}

void merge_states(void)
{
  int classes, s, s1, e, sh;
  struct state * sp, * sp1, * qL, * qR;

  e_tab = 0, e_max = 0;
  for (s = 0; s < s_s; s++)
    {
      sp = &s_tab[s];
      if (sp->class != s)
	continue;
      for (s1 = 0; s1 < s; s1++)
        {
          sp1 = &s_tab[s1];
          if (sp1->class != s1)
	    continue;
          e_s = 0, add_equiv(s, s1);
          for (e = 0; e < e_s; e++) {
            qL = e_tab[e].L, qR= e_tab[e].R;
            if (qL->empty != qR->empty || qL->shifts != qR->shifts)
              goto NOT_EQUAL;
            for (sh = 0; sh < qL->shifts; sh++)
              if (qL->sh_list[sh].LHS != qR->sh_list[sh].LHS)
                goto NOT_EQUAL;
            for (sh = 0; sh < qL->shifts; sh++)
              add_equiv(qL->sh_list[sh].RHS, qR->sh_list[sh].RHS);
          }
EQUAL: break;
NOT_EQUAL: continue;
        }
      if (s1 < s)
	{
          for (e = 0; e < e_s; e++)
	    {
              struct state * qL=e_tab[e].L, * qR= e_tab[e].R;
              qR->class = qL->class;
            }
	}
    }

    for (classes = 0, s = 0; s < s_s; s++) 
      {
       sp = &s_tab[s];
        sp->class = (sp->class == s) ? classes++: s_tab[sp->class].class;
      }
}

/* ȯ ̺ ݴ  */
void make_reverse(int ** a, int s)
{
  int i=0, j=0;

#ifdef HG_RE_DEBUG
  printf ("ݴ: %d\n", s);
#endif
  for (i=0; i<ENG_RANGE; i++)
    {
      if (a[0][i] == -1)
        a[0][i] = s+1;
      else
        a[0][i] = 0;
    }
  for (j=1; j<DFA_TABLE_NUM; j++)
    {
      for (i=0; i<KOR_RANGE; i++)
        {
          if (a[j][i] == -1)
            a[j][i] = s+1;
          else 
            a[j][i] = 0;
        }
    }
}

/* accept   */
void make_one(int ** a)
{
  int i=0, j=0;

  for (i=0; i<ENG_RANGE; i++)
    {
      if (a[0][i] == -1)
        a[0][i] = 0x6163;
    }
  for (j=1; j<DFA_TABLE_NUM; j++)
    {
      for (i=0; i<KOR_RANGE; i++)
        {
          if (a[j][i] == -1)
            a[j][i] = 0x6163;
        }
    }
}

/* Ÿ  . ǥ ȯ ̺  */
void make_dot(int ** a, int s)
{
  int i=0, j=0;
  int newline_value=a[0]['\n'];

  for (i=0; i<ENG_RANGE; i++)
    a[0][i] = s;
  for (j=1; j<DFA_TABLE_NUM; j++)
    {
      for (i=0; i<KOR_RANGE; i++)
	a[j][i] = s;
    }

  /* '\n'  ܽŴ */
  a[0]['\n'] = newline_value;
}

/* ȯ ̺     κ -1  õǾ ִµ,
 *      -1  Ǿ ִ κ 0 ش.
 * ̰  0          ̴. */
void remove_minus (int ** a)
{
  int i, j;

  for (i=0; i<ENG_RANGE; i++)
    {
      if (a[0][i] == -1)
        a[0][i] = 0;
    }
  for (i=1; i<DFA_TABLE_NUM; i++)
    {
      for (j=0; j<KOR_RANGE; j++)
        if (a[i][j] == -1) a[i][j] = 0;
    }
}

/* ȯ ̺ Ҵ Լ */
int ** allocate_dfa_table (void)
{
  int ** a;
  int * b;
  int i, j;

  /*   Ȱ */
  MALLOC (a, int *, DFA_TABLE_NUM);
  MALLOC (b, int, ENG_RANGE);
  a[0] = b;
  for (i=0; i<ENG_RANGE; i++)
    a[0][i] = -1;
  for (i=1; i<DFA_TABLE_NUM; i++)
    {
      MALLOC (b, int, KOR_RANGE);
      for (j=0; j<KOR_RANGE; j++)
	b[j] = -1;
      a[i] = b;
    }

  return a;
}

/* Ÿ  ^  $   ȯ ̺  */
void make_ssac_money (struct dfa_array * dfa_table, int s, int s1)
{
  int ** a;

  a = allocate_dfa_table ();
  a[0]['\n'] = s1;
  dfa_table[s].trans = a;
  remove_minus (a);
#if HG_RE_DEBUG
  prt_trans(a, 0, 1, 0);
#endif
}

/* ΰ ̺ պմϴ. */
int
merge_trans (struct dfa_array dst_dfa, struct dfa_array src_dfa)
{
  int ** td, ** ts;
  int i, j;
  
  td = dst_dfa.trans;
  ts = src_dfa.trans;
  for (i=0; i<ENG_RANGE; i++)
    {
      if (ts[0][i] > 0 && (td[0][i] == -1 || td[0][i] == 0))
        {
	  if(td[0][i] > 0)
	    printf("   ° 0 ƴմϴ-%d", td[0][i]);
	  else
	    td[0][i] = ts[0][i];
	}
    }
  for (i=1; i<DFA_TABLE_NUM; i++)
    {
      for (j=0; j<KOR_RANGE; j++)
        {
          if (ts[i][j] > 0 && (td[i][j] == -1 || td[i][j] == 0))
	    {
	      if(td[i][j] > 0)
	        printf("   ° 0 ƴմϴ-%d", td[0][i]);
	      else
	        td[i][j] = ts[i][j];
	    }
	}
    }

  return 0;
}

/* { } ǥ  Merge  Ѵ */
void
merge_lopt_repeat (struct dfa_array * dfa, int s, int ls, int le)
{
  int i;
  
  for (i=0; i<(le-ls); i++)
    {
      (void) merge_trans (dfa[s+i+ls], dfa[s+(le-ls)+ls]);
    }
}


struct dfa_array *
write_states (void)
{
  int s, s1, sh, classes, c, i, lopt_state=-1, lopt_ob=-1, lopt_ob2=0;
  int ssac=0, money=0;
  int ** a;
  struct dfa_array * dfa_table;
  struct state * sp;

  MALLOC (dfa_table, struct dfa_array, DFA_TABLE_MAX);
  for (s = classes = 0; s < s_s; s++) {
    sp = &s_tab[s];
    if (sp->class != classes) continue;
    classes++;
    if (sp->ssac_got) {
      ssac=1;
#ifdef HG_RE_DEBUG
      printf ("Q%d = ^ Q%d\n", sp->class, sp->class+ssac);
#endif
      make_ssac_money (dfa_table, sp->class, sp->class+ssac);
    }

    a = allocate_dfa_table ();
    s1 = sp->class+ssac+money;
    dfa_table[s1].trans = a;
    dfa_table[s1].index = s1+100;
#ifdef HG_RE_DEBUG
    printf ("Q%d =", s1);
#endif
    if (sp->money) money=1;
    for (sh = 0; sh < sp->shifts; sh++) {
      char * n;
      int x=0, y;
      c = sp->sh_list[sh].RHS;
#ifdef HG_RE_DEBUG
      if (sh > 0) printf (" |");
#endif
      if (sp->sh_list[sh].LHS == NULL) {
#ifdef HG_RE_DEBUG
        printf (". Q%d ", s_tab[c].class+ssac);
#endif
        make_dot(a, s_tab[c].class+ssac);
        continue;
      }
      n = sp->sh_list[sh].LHS->name;
      if (hg_ishangul (n[0], n[1])) {
        x = ((int) (n[0] & 0xff)) - KOR_FSTB_P + 1;
        y = ((int) (n[1] & 0xff)) - KOR_SNDB_P;
        if (x<0) x = 0x1a;
        a[x][y] = s_tab[c].class+ssac;
#ifdef HG_RE_DEBUG
        printf (" %s Q%d", sp->sh_list[sh].LHS->name, 
              s_tab[c].class+ssac);
#endif
      } else {
        y = (int) (n[0] & 0xff);
        a[x][y] = s_tab[c].class+ssac;
#ifdef HG_RE_DEBUG
        printf (" %s Q%d", sp->sh_list[sh].LHS->name, 
              s_tab[c].class+ssac);
#endif
      }
    }
    if (sp->reverse) {
      make_reverse(a, s1);
#ifdef HG_RE_DEBUG
      printf (" [REVERSE]");
#endif
    }
    if (sp->empty) {
#ifdef HG_RE_DEBUG
      if (sp->shifts > 0) printf (" |");
#endif
      make_one(a);
#ifdef HG_RE_DEBUG
      printf (" 1");
#endif
    }
#ifdef HG_RE_DEBUG
    putchar ('\n');
#endif
    if (sp->money) {
#ifdef HG_RE_DEBUG
      printf ("Q%d = $ Q%d\n", s_tab[c].class+ssac, 
             s_tab[c].class+ssac+money);
#endif
      make_ssac_money (dfa_table, s_tab[c].class+ssac, s_tab[c].class+ssac+money);
    }
    remove_minus (a);
#if HG_RE_DEBUG
    prt_trans(a, 0x0, 0x0, 0);
#endif
  }

  ssac=money=0;
  for (s = classes = 0; s < s_s; s++)
    {
      sp = &s_tab[s];
      if (sp->class != classes) continue;
      classes++;
      if (sp->ssac_got) ssac=1;
      s1 = sp->class+ssac+money;
      if (sp->money) money=1;
      if (sp->lopt_merge) lopt_state = s1;
      if (lopt_state != -1 && lopt_state >= 0 && (lopt_ob2 != lopt_state)
	  && sp->lopt_merge)
        {
	  lopt_ob2 = lopt_state;
	  lopt_ob += 1;
	  merge_lopt_repeat (dfa_table, lopt_state, lopt_merge_start[lopt_ob], lopt_merge_end[lopt_ob]);
	}
    }

  /*  ʴ ޸𸮸   մϴ. */
  /* free all memories */
  for (s = 0; s < s_s; s++) {
    sp = &s_tab[s];
          while (c < sp->shifts) {
      if (sp->sh_list[c].LHS != NULL) {
        free (sp->sh_list[c].LHS->name);
        free (sp->sh_list[c].LHS);
      }
      c++;
    }
    free (sp->sh_list);
  }
  free (s_tab);
  free (x_stack);
  /* free mm that equ_tab */
  for (i=0; i < equ_max; i++) {
    if ( equ_tab[i].index == 100 ) {
      if ( equ_tab[i].value->args > 0 ) free (equ_tab[i].value->body.arg);
      free (equ_tab[i].value);
    }
  }
  free (equ_tab);
  /* free memories that i_max pointer ( struct item * ) */
  for (i=0; i < i_max; i++) {
    if (i_buf[i].index == 100) {
      if ( i_buf[i].RHS ) free (i_buf[i].RHS);
    }
  }

  return dfa_table;
}

void
prt_trans(int ** trans, int start, int end, int mode)
{
  int i,j;
  int z=0;

  if (mode == 0) {
    for (i=start; i<=end; i++) {
      if (trans[i]) {
        printf ("trans[%x][0~255]", i);
        for (j=0x0;j<KOR_RANGE;j++) {
          if (!(j%16)) printf ("\n");
          printf ("%4x", trans[i][j]);
        }
        printf ("\n");
      } else break;
    }
  } else if (mode == 1) {
    for (i=start; i<=end; i++) {
      if (trans[i]) {
        for (j=1;j<KOR_RANGE;j++)
          if (trans[i][j]) z++;
        if (z) printf ("trans[%d] : ", i);
        for (j=1;j<KOR_RANGE;j++)
          if (trans[i][j]) printf ("[%x]-%d ", j, trans[i][j]);
        if (z) printf ("\n");
        z=0;
      } else break;
    }
  }
}

char *
prt_stack_tag(int i)
{
  switch (i)
    {
      case 0 : return "RULE";
      case 1 : return "PAR";
      case 2 : return "LPAR";
      case 3 : return "OPT";
      case 4 : return "OR";
      case 5 : return "BAR";
      case 6 : return "CORON";
      case 7 : return "COMMA";
      case 8 : return "AND";
      case 9 : return "SSAC";
    }

  return "";
}

void
show_stack(void)
{
  int i=0;

  while (i <= 500 && stack[i].q != 0)
    {
      printf ("tag : %s, q = %d\n", prt_stack_tag(stack[i].tag), stack[i].q);
      i++;
    }
}

void
prt_x_stack (void)
{
  int i=0;

  printf ("Stack  : ");
  while (i<8)
    {
      if (x_stack[i] < 100 && x_stack[i] > 0)
        printf ("%d ", x_stack[i]);
      else
        printf ("0 ");
      i++;
    }
  printf ("\n");
}

void
prt_s_tab(struct state * SP)
{
  int j=0;
  int i=0;

  printf ("---+-------+-------+-------+-------+-------+-------+------\n");
  printf ("Ŭ |   |*SList | SMRL  |Empty  |Shift  |Sh.LHS |Sh.RHS\n");
  printf ("-------+-------+-------+-------+-------+-------+-------+------\n");
BEGIN:
  if (SP->class > 100 || SP->states > 100)
        goto END;
  printf ("%6d | %5d | ", SP->class, SP->states);
  while (j<2)
    {
      if (SP->s_list[j] < 100 && SP->s_list[j] > 0)
        printf ("%2d ", SP->s_list[j]);
      else
        printf (" 0 ");
      j++;
    }
  j=0;
  printf ("| %d%d%d%d   | %5d | %5d | ", SP->ssac_got, SP->money, SP->reverse, SP->lopt_merge, SP->empty, SP->shifts);
  while (i < SP->shifts)
    {
      if (SP->sh_list[i].LHS == NULL)
        printf ("NU ");
      else
        printf ("%2s ", SP->sh_list[i].LHS->name);
      i++;
    }
  i=0;
  if (SP->shifts == 0)
    printf ("      | ");
  else if (SP->shifts == 1)
    printf ("   | ");
  else 
    printf ("| ");
  while (j<SP->shifts)
    {
      if (SP->sh_list[j].RHS < 100 && SP->sh_list[j].RHS > 0)
        printf ("%2d ", SP->sh_list[j].RHS);
      else 
        printf (" 0 ");
      j++;
    }
  j=0;
  printf ("\n");
  if (s_tab != SP)
    {
      SP = SP - 1;
      goto BEGIN;
    }
END:
  printf ("-------+-------+-------+-------+-------+-------+-------+------\n");
}

void
prt_i_buf (struct item * t)
{
  int j=0;

  printf ("========+=======+=================\n");
  printf ("LSH.̸|ũ   | *RHS\n");
  printf ("========+=======+=================\n");
KKK:
  if (t->LHS == NULL)
    printf ("NULL | %5d | ", t->size);
  else
    printf ("%7s | %5d | ", t->LHS->name, t->size);
  while (j<8)
    { 
      if (t->RHS[j] > 0)
        printf ("%d ", t->RHS[j]);
      else
        printf ("0 ");
      j++; 
    }
  printf ("\n");
  j=0;
  if (i_buf != t)
    {
      t = t - 1;
      goto KKK;
    }
  printf ("========+=======+=================\n");
}


char *
prt_equtab_tag(int i)
{
  switch (i)
    {
      case 0 :  return "";
      case 1 :  return ".";
      case 2 :  return "^";
      case 3 :  return "$";
      case 4 :  return "\\";
      case 5 :  return "0";
      case 6 :  return "1";
      case 7 :  return "&";
      case 8 :  return "|";
      case 9 :  return "-";
      case 10 : return "*";
      case 11 : return "+";
      case 12 : return ",";
      case 13 : return "[";
      case 14 : return "{";
      case 15 : return ":";
      case 16 : return "?";
    }

  return "";
}

/* ǥĿ    equ_tab ü 
 * ȭ鿡 ѷ ݴϴ. */
void
prt_equtab(int start, int end)
{
  int i=start;

  printf ("------------------------+------+------+------+\n");
  printf (" ǥ                 |Ŭ| ؽ |  |\n");
  printf ("------------------------+------+------+------+\n");
  while (i <= end)
    {
      if (equ_tab[i].value)
        {
          if ( equ_tab[i].value->args == 0 )
	    {
              if ( equ_tab[i].value->tag == 5 || equ_tab[i].value->tag == 6 )
                printf (" E%d   -> %d\t\t", i, equ_tab[i].value->tag-5);
	      else if ( equ_tab[i].value->tag == 1 )
                printf (" E%d   -> .\t\t", i);
	      else if ( equ_tab[i].value->tag == 16 )
                printf (" E%d   -> ?\t\t", i);
              else
                printf (" E%d   -> %s\t\t", i, equ_tab[i].value->body.leaf->name);
            }
	  else if ( equ_tab[i].value->args == 1 )
            printf (" E%d   -> E%d %s\t\t", i, (equ_tab[i].value->body.arg[0]),
		                            prt_equtab_tag(equ_tab[i].value->tag));
          else if ( equ_tab[i].value->args == 2 )
            printf (" E%d   -> E%d %s E%d\t", i, (equ_tab[i].value->body.arg[0]),
		                              prt_equtab_tag(equ_tab[i].value->tag),
					      equ_tab[i].value->body.arg[1]);
          printf ("| %4x | %4x | %4d | \n", equ_tab[i].value->class, equ_tab[i].hash, equ_tab[i].stack);
      } else
        break;
      i++;
    }
  printf ("------------------------+------+------+------+\n");
}

struct dfa_array *
hg_regexp_compile (char * re)
{
  int q;
  struct dfa_array * dfa_table;

  /* When occur segment fault */
  signal(SIGSEGV, hg_re_seg_fault);

  general_init ();

  q = parse (re);
  if (q==-1)
    {
      printf("Խ м    մϴ.\n");
      exit(1);
    }

#if HG_RE_DEBUG
  printf ("Խ: %s\n", re);
  printf ("[]: ļ Ʈ ǥ -------------------\n");
  prt_equtab(0,500);
#endif
  form_state(q);
  merge_states();
#if HG_RE_DEBUG
  printf ("[]: ļ Ʈ -> Merge  -> DFA  ǥ -----------\n");
  prt_equtab(0,500);
#endif
  dfa_table = write_states ();
  
  return dfa_table;
}

void
hg_regexp_search (struct dfa_array * re, char * buf)
{
  int ** t, s=0, s1=0, is_end=0, pos=0, pos1=0;

  re->pos = -1;
  while ( (t = re[s].trans) != NULL )
    {
      int x=0, y;

      if (*buf == '\0') is_end++;
      if (hg_ishangul (*buf, *(buf+1)))
        {
          x = ((int) ((*buf) & 0xff)) - KOR_FSTB_P + 1;
          y = ((int) ((*(buf+1)) & 0xff)) - KOR_SNDB_P;
          if (x<0) x = 0x1a;
          s = t[x][y];
          if (s == 0x6163) break;
          else if (s) s1 = s, pos+=2;
          else if (s1 && s == 0) buf-=2, pos-=2, pos1-=2, s1=0;
          buf+=2, pos1+=2;
        }
      else
        {
          y = (int) ((*buf) & 0xff);
          s = t[x][y];
          if (s == 0x6163) break;
          else if (s) s1 = s, pos++;
          else if (s1 && s == 0) buf--, pos--, pos1--, s1=0;
          buf++, pos1++;
        }
      if (is_end) break;
    }
  
  if (s == 0x6163)
    re->pos = pos1-pos;
}

void
hg_regexp_free (struct dfa_array * re)
{
  int i=0, j=0;
  int ** t;

  while (re[i].index != 0)
    {
      t = re[i].trans;
      for (j=0; j<DFA_TABLE_NUM; j++)
        free (t[j]);
      i++;
    }

  free (re);
}
